export declare enum OpCode {
    Eof = 0,
    Const = 1,
    Add = 2,
    Sub = 3,
    Mul = 4,
    Div = 5,
    LT = 6,
    LTE = 7,
    GT = 8,
    GTE = 9,
    StrictEQ = 10,
    StrictNEQ = 11,
    Push = 12,
    Drop = 13,
    Dup = 14,
    Over = 15,
    Swap = 16,
    Def = 17,
    DefBlock = 18,
    Load = 19,
    Set = 20,
    Jump = 21,
    JumpIfTrue = 22,
    JumpIfFalse = 23,
    EnterBlockScope = 24,
    EnterLabeledBlockScope = 25,
    EnterIterableBlockScope = 26,
    ExitBlockScope = 27,
    Break = 28,
    BreakLabel = 29,
    Ret = 30,
    Call = 31,
    CallMethod = 32,
    Null = 33,
    Undefined = 34,
    False = 35,
    True = 36,
    Zero = 37,
    CreateArray = 38,
    CreateFunction = 39,
    CreateLambda = 40,
    CreateObject = 41,
    This = 42,
    New = 43,
    PropAccess = 44,
    PropAssignment = 45,
    ForInStart = 46,
    ForInNext = 47,
    ForOfStart = 48,
    ForOfNext = 49
}
export interface OpValue {
    value: number;
}
export interface Label extends OpValue {
}
