import { OpCode, OpValue } from './opcode';
import { VMDump, DoneResult, ExecResult, JSPropertyDescriptor, Callable } from './types';
import { VObject, JSNumber, JSFunction, JSString, JSObject, JSForInOrOfIterator } from './value';
export default class VirtualMachine implements Callable {
    private codes;
    private values;
    private cur;
    private stack;
    private frames;
    private environments;
    constructor(codes?: (OpCode | OpValue)[], values?: VObject[], cur?: number);
    private initGlobal;
    private popStack;
    private popCode;
    private lookup;
    private define;
    private setValue;
    dump(): VMDump;
    load(dump: VMDump): void;
    step(): DoneResult;
    exec(step: true): ExecResult;
    exec(step?: false): DoneResult;
    call(callee: JSFunction, args: VObject[], thisObject: VObject): void;
    getProp(obj: JSObject, curr: JSObject, key: JSString | JSNumber): void;
    getValueByDescriptor(obj: JSObject, descriptor: JSPropertyDescriptor): void;
    forInNext(iter: JSForInOrOfIterator): void;
    forOfNext(iter: JSForInOrOfIterator): void;
}
